part of viltage;

class Input {
  List<bool> _keys = new List<bool>();
  List<bool> _lastKeys = new List<bool>();
  List<bool> _banKeys = new List<bool>();
  
  Input() {
    for(int i = 0; i < 256; i++) {
      _keys.add(false);
      _lastKeys.add(false);
      _banKeys.add(false);
    }
    
    window.onKeyDown.listen((KeyboardEvent e) {
        _keys[e.keyCode]=true;
        e.stopPropagation();
    });

    window.onKeyUp.listen((KeyboardEvent e) {
      _keys[e.keyCode]=false;
      e.stopPropagation();
    });
  }

  bool isHeld(int keyCode) => _keys[keyCode];
  
  bool isPressed(int keyCode) => _lastKeys[keyCode];
  
  load() {
    for(int i = 0; i < 256; i++) {
       if(_lastKeys[i] || _banKeys[i]) {
         _lastKeys[i]=false;
         _banKeys[i] =true;
       } else if(_keys[i]) {
         _lastKeys[i]= true; 
       }
    }
  }
  
  end() {
    for(int i = 0; i < 256; i++) {
      if(!_keys[i]) _banKeys[i]=false;
    }
  }
  
}